/***********************************************************************
 * File: data.c
 * 	(Extracted from
 *	   "$Id: write_csv_columns_test.c,v 1.2 2009/05/24 09:57:53 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This C source code implements a test-program of the converter set
 * for the CSV-files "csv_converter.c".
 *
 * Copyright (C) 2004-2007 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/


/* include definitions */
#include "csv_converter.h"

int main(int ac, char **av)
{
#	define	TEST_FILE "test_file_2.csv"
	size_t	i, gprof_cnt, gprof_iter_max;
	FILE	*fd = NULL;
	long	column_pos = 0L;
	char	number[2], delimit = DLMT_COMMA;

	for (gprof_iter_max = (size_t)(((ac == 2 && strcmp(av[1], "-P") == 0)
									|| (ac == 3 && strcmp(av[2], "-P") == 0)
									)?							2000: 1
								)
		, gprof_cnt = 0
	; gprof_cnt < gprof_iter_max
	; ++gprof_cnt
	) {	/* iterate the unit test for gprof profiling... */
	if ((ac == 2) && strcmp(av[1], "-P") != 0) {	delimit	= av[1][0];	}

	if ((fd = write_csv_columns(TEST_FILE
								, (const char)delimit
								, fd
								, &column_pos
								, CSV_CONTINUE
								)) == NULL
	) {
		printf("%s:%d: errno = %d, fd = %p, column_pos = %ld\n"
			, __FILE__, __LINE__, errno, (void *)fd, column_pos
			); (void)fflush(stdout)
			;
		exit(1);
	}

	for (i = 0; i < 3; ++i) {
		(void)snprintf((char *)memset(number, (int)'\0', sizeof(number))
						, sizeof(number)
						, "%.*u"
						, (int)(sizeof(number) - 1), (unsigned)i
						);
		if ((fd = write_csv_columns(NULL, (const char)delimit, fd
									, &column_pos
									, CSV_EMPTY,	i
									, CSV_COLUMN,	strlen(number), number
									, CSV_EMPTY,	5
									, CSV_COLUMN,	1, "AAA"
									, CSV_EOL
									, CSV_EMPTY,	4
									, CSV_COLUMN,	2, "BBB"
									, CSV_EOL
									, CSV_COLUMN,	5, "C,\",C"
									, CSV_COLUMN,	1, "\t"
									, CSV_COLUMN,	1, ","
									, CSV_EOL
									, CSV_COLUMN,	2, "3210"
									, CSV_CONTINUE
									)) == NULL
		) {
			printf("%s:%d: errno = %d, fd = %p, column_pos = %ld\n"
				, __FILE__, __LINE__, errno, (void *)fd, column_pos
				); (void)fflush(stdout)
				;
			exit(1);
		}
	}

	if ((fd = write_csv_columns(NULL, (const char)delimit, fd, &column_pos
								, CSV_COLUMN,	3, "D\nD"
								, CSV_CONTINUE
								)) == NULL
	) {
		printf("%s:%d: errno = %d, fd = %p, column_pos = %ld\n"
			, __FILE__, __LINE__, errno, (void *)fd, column_pos
			); (void)fflush(stdout)
			;
		exit(1);
	}

	if ((fd = write_csv_columns(NULL, (const char)delimit, fd, &column_pos
								, CSV_END
								)) == NULL
	) {
		printf("%s:%d: errno = %d, fd = %p, column_pos = %ld\n"
			, __FILE__, __LINE__, errno, (void *)fd
			,				column_pos
			); (void)fflush(stdout)
			;
		exit(1);
	}
	} /* iterate the unit test for gprof profiling... */

	exit(0);
}
